import JWT from '../Libraries/JWT.js';
import { PERMISSIONS } from './Permissions.js';

const PermissionManager = {
    userHasPermissionTo (operation, routeName, token){
        let permissionGranted = false;
        const operations = ["find", "insert", "update", "delete"];
        if( operations.includes(operation) ){
            let userInfo = JWT.getTokenData(token);
            if( userInfo.GRANT_ALL || PERMISSIONS[operation].NOCHECK.includes(routeName)  ){
                permissionGranted = true;
            } else {
                // TODO: Review AccessControl
                ////scopeIDS = self::_findInPermissionsArray(PERMISSIONS[operation], routeName);
                ////permissionGranted = !empty(array_intersect(scopeIDS, userInfo["SCOPES"]));
                permissionGranted = true;
            }
        } else {
            permissionGranted = false; //invalid operation
        }

        return permissionGranted;
    }
}

const { userHasPermissionTo } = PermissionManager;
export {
    userHasPermissionTo
}

export default PermissionManager;