<?php

namespace Teknisa\Libs\Util\Log;

use Teknisa\Libs\Util\Repositories\ZhuLog as ZhuLogRepository;
use Teknisa\Libs\Util\Utilities;

class ZhuLogProvider implements ZhuLog {
    /** @var ZhuLogRepository $zhuLogRepository */
    protected $zhuLogRepository;

    /**
     * @param ZhuLogRepository $zhuLogRepository
     */
    public function __construct(ZhuLogRepository $zhuLogRepository) {
        $this->zhuLogRepository = $zhuLogRepository;
    }

    /**
     * @param Filters $conditions
     * @param Number $page
     * @param Limit $pageSize
     * @return array
     */
    public function find($conditions, $page, $pageSize) {
        $filters = '';
        foreach($conditions as $key => &$filter) {
            if($filter['columnName'] == 'USER_ID') {
                $filters .= Utilities::USER_ID_FILTER_ZHU_LOG . $filter['value'] . "')";
                unset($conditions[$key]);
            } else if ($filter['columnName'] == 'USER_NAME') {
                $filters .= Utilities::USER_NAME_FILTER_ZHU_LOG . $filter['value'] . "')";
                unset($conditions[$key]);
            } else if ($filter['columnName'] == 'CONTAINER_LABEL') {
                $filters .= Utilities::CONTAINER_LABEL_FILTER_ZHU_LOG . $filter['value'] . "')";
                unset($conditions[$key]);
            } else if ($filter['columnName'] == 'WIDGET_LABEL') {
                $filters .= Utilities::WIDGET_LABEL_FILTER_ZHU_LOG . $filter['value'] . "')";
                unset($conditions[$key]);
            } else if ($filter['columnName'] == 'ROUTE_LABEL') {
                $filter['columnName'] = 'ROUTE';
            } else if ($filter['columnName'] == 'TYPE') {
                $filters .= " AND " . $filter['columnName'] . $filter['operator'] . "'" . $filter['value'] . "'";
                unset($conditions[$key]);
            } else if (strpos($filter['columnName'], 'TIMESTAMP_') !== false) {
                $filters .= " AND TIMESTAMP " . $filter['operator'] . $filter['value'];
                unset($conditions[$key]);
            }
        }
        $defaultFilters = Utilities::createQueryFiltered($conditions);
        $limit = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        return $this->zhuLogRepository->getZhuLog($filters . $defaultFilters, $limit, $offset);
    }
} 